=== debian/changelog ===
openttd-opengfx (0.5.1-2) unstable; urgency=medium

  * [8960e28] Bump Standards-Version to 3.9.6, no changes required.
  * [0b69091] Install into /usr/share/games/openttd/baseset.
  * [db7b301] Reverse direction of readme and changelog symlinks.

 -- Matthijs Kooijman <matthijs@stdin.nl>  Thu, 23 Oct 2014 12:52:16 +0200

openttd-opengfx (0.5.1-1) unstable; urgency=medium

  * [8c443ad] New upstream release 0.5.1.
  * [cd7ec8b] Depend on grfcodec
  * [9978dc6] Bump Standards-Version to 3.9.5, no changes required.
  * [e4da992] Use canonical Vcs urls (on anonscm.debian.org).
  * [cd20286] Remove fix-distclean.patch
  * [7da3d3b] Update debian/rules to upstream Makefile changes
  * [08f1151] Bump nml build-depend to >= 0.3.0.
  * [5f716d2] Add lintian override for license symlink.

 -- Matthijs Kooijman <matthijs@stdin.nl>  Sun, 11 May 2014 15:08:57 +0200
