=== debian/changelog ===
openttd-opengfx (0.5.4-2~mx17+1) mx; urgency=medium

  * Repackaged for MX-17/18.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Fri, 22 Feb 2019 18:32:50 -0800

openttd-opengfx (0.5.4-2) unstable; urgency=medium

  * [1f3c254] Bump debhelper version to v11
  * [6fbd713] Bump standards version to 4.1.4
  * [43960c7] Convert Priority: extra to optional
  * [71adcda] Mark as Multi-arch: foreign
  * [45487e7] Respect nocheck in DEB_BUILD_OPTIONS
  * [688989a] Use python3 instead of python during the build
    (Closes: #897544)
  * [0908f53] Add build dependency on python3

 -- Matthijs Kooijman <matthijs@stdin.nl>  Thu, 10 May 2018 21:44:24 +0200

openttd-opengfx (0.5.4-1) unstable; urgency=medium

  * [c6d97c8] New upstream release 0.5.4.

 -- Matthijs Kooijman <matthijs@stdin.nl>  Thu, 07 Jan 2016 15:32:02 +0100

openttd-opengfx (0.5.3-1) unstable; urgency=medium

  * [7ee9c82] New upstream release 0.5.3.

 -- Matthijs Kooijman <matthijs@stdin.nl>  Tue, 22 Sep 2015 21:03:13 +0200
