=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 export GIMP2_DIRECTORY=$(CURDIR)/gimp-data
 
 %:
-	dh $@ --parallel
+	dh $@
 
 INSTALL_ROOT=debian/openttd-opengfx
 DATA_DIR=usr/share/games/openttd/baseset/opengfx
@@ -23,6 +23,7 @@
 OPTIONS=
 OPTIONS += "INSTALL_DIR=$(INSTALL_ROOT)/$(DATA_DIR)"
 OPTIONS += "_V="
+OPTIONS += "PYTHON=python3"
 
 override_dh_auto_build:
 	# Remove all graphics files that can be rebuilt (from gimp xcf
@@ -49,12 +50,18 @@
 	dh_installchangelogs docs/changelog.txt
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# Check if the md5 sums of the resulting grf files match. This
 	# ensures no problems will arise in online play, which uses both
 	# version info and md5 sums of files.
 	make check $(OPTIONS)
+endif
 
 override_dh_auto_clean:
 	make distclean $(OPTIONS)
 	# Remove any data created by gimp
 	rm -rf "$(GIMP2_DIRECTORY)"
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
+
