=== debian/changelog ===
openttd-opengfx (0.5.5-1) unstable; urgency=medium

  * [8cd58df] New upstream release 0.5.5
  * [4222702] Support DEB_BUILD_OPTIONS=terse
  * [e03f695] Bump standards version to 4.3.0
  * [fecd86e] Update upstream urls to Github
  * [cf2adc6] Prevent GIMP from trying to write thumbnails

 -- Matthijs Kooijman <matthijs@stdin.nl>  Wed, 10 Apr 2019 08:10:36 +0200
