=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: openttd-opengfx
 Section: games
 Priority: optional
-Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
-XSBC-Original-Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
+Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
 Uploaders: Jordi Mallach <jordi@debian.org>
 Build-Depends: debhelper (>= 11), nml (>= 0.3.0), gimp, grfcodec, python3
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/openttd-team/openttd-opengfx
 Vcs-Git: https://salsa.debian.org/openttd-team/openttd-opengfx.git
-Homepage: http://dev.openttdcoop.org/projects/opengfx
+Homepage: https://github.com/OpenTTD/OpenGFX
 
 Package: openttd-opengfx
 Architecture: all
