=== debian/rules ===
--- 
+++ 
@@ -9,8 +9,13 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-# Make sure that gimp doesn't read or write data into $HOME/.gimp-2.6
-export GIMP2_DIRECTORY=$(CURDIR)/gimp-data
+# Make sure that gimp doesn't read or write data into $HOME/.gimp-2.6 or
+# elsewhere
+export GIMP2_DIRECTORY=$(CURDIR)/build-data/gimp-data
+export GIMP3_DIRECTORY=$(CURDIR)/build-data/gimp-data
+export XDG_DATA_HOME=$(CURDIR)/build-data/share
+export XDG_CACHE_HOME=$(CURDIR)/build-data/cache
+export XDG_CONFIG_HOME=$(CURDIR)/build-data/config
 
 %:
 	dh $@
@@ -22,7 +27,11 @@
 
 OPTIONS=
 OPTIONS += "INSTALL_DIR=$(INSTALL_ROOT)/$(DATA_DIR)"
+ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
+# By default, _V is set to @ to suppress commands, clear it to *show*
+# commands.
 OPTIONS += "_V="
+endif
 OPTIONS += "PYTHON=python3"
 
 override_dh_auto_build:
@@ -61,7 +70,3 @@
 	make distclean $(OPTIONS)
 	# Remove any data created by gimp
 	rm -rf "$(GIMP2_DIRECTORY)"
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
-
