## openttd-opengfx 0.6.0

=== Makefile ===
--- 
+++ 
@@ -32,17 +32,15 @@
 # Define the filenames of the grf and nml file. They must be in the main directoy
 GRF_FILES            ?= $(addsuffix .grf,$(BASE_FILENAME))
 NML_FILES            ?= $(addsuffix .nml,$(BASE_FILENAME))
+DEP_FILES            ?= $(addsuffix .grf.dep,$(BASE_FILENAME)) $(addsuffix .nml.dep,$(BASE_FILENAME))
 PNML_FILES           ?= $(addsuffix .pnml,$(BASE_FILENAME))
 DOC_FILES            ?= $(LICENSE_FILE) $(CHANGELOG_FILE) $(README_FILE)
 LNG_FILES            ?= lang/*.lng
 GFX_FILES            ?=
 
-# List of all files which will get shipped
-# documentation files: readme, changelog and license, usually $(DOC_FILES)
-# grf file: the above defined grf file, usualls $(GRF_FILES)
-# Add any additional, not usual files here, too, including
-# their relative path to the root of the repository
-BUNDLE_FILES           ?= $(GRF_FILES) $(DOC_FILES) $(OBG_FILENAME)
+# List of all files which will get shipped, minus documentation files.
+# Documentation files often are generated from other files.
+BUNDLE_FILES           ?= $(GRF_FILES) $(OBG_FILENAME)
 BANANAS_INI            ?= bananas.ini
 
 # Replacement strings in the source and in the documentation
@@ -50,7 +48,6 @@
 # (unless you know where to add them in other places, too)
 REPLACE_TITLE       := {{REPO_TITLE}}
 REPLACE_GRFID       := {{GRF_ID}}
-REPLACE_REVISION    := {{REPO_REVISION}}
 REPLACE_FILENAME    := {{FILENAME}}
 
 # target 'all' must be first target
@@ -64,9 +61,9 @@
 # general definitions (no rules!)
 -include Makefile.dist
 .PHONY: all clean distclean
-.PHONY: bananas doc gfx grf lng nml obg
+.PHONY: bananas gfx grf lng nml obg
 .PHONY: bundle     bundle_tar bundle_bzip bundle_gzip bundle_xz   bundle_zip
-.PHONY: bundle_src check      bundle_bsrc bundle_gsrc bundle_xsrc bundle_zsrc 
+.PHONY: bundle_src check      bundle_bsrc bundle_gsrc bundle_xsrc bundle_zsrc
 
 # We want to disable the default rules. It's not c/c++ anyway
 .SUFFIXES:
@@ -77,7 +74,7 @@
 
 FORCE:
 
--include *.dep
+-include $(DEP_FILES)
 
 
 ################################################################
@@ -91,19 +88,16 @@
 MAKE_FLAGS     ?= -r
 
 # Version control system
-HG                  ?= hg
-DEFAULT_BRANCH_NAME ?= default
-HG_ARCHIVE_FLAGS    ?= -X .hgtags -X .hgignore -X .devzone -X scripts/make_changelog.sh
+GIT                 ?= git
+DEFAULT_BRANCH_NAME ?= master
 
 # Text processing and scripting
 AWK            ?= awk
 GREP           ?= grep
 PYTHON         ?= python
-UNIX2DOS       ?= $(shell which unix2dos)
-UNIX2DOS_FLAGS ?= $(shell [ -n $(UNIX2DOS) ] && $(UNIX2DOS) -q --version 2>/dev/null && echo "-q" || echo "")
 
 # Graphics processing
-GIMP           ?= gimp
+GIMP           ?= $(shell which gimp)
 GIMP_FLAGS     ?= -n -i
 
 # NML
@@ -122,11 +116,11 @@
 endif
 
 # GRF tools
-GRFID          ?= grfid
+GRFID          ?= $(shell which grfid)
 GRFID_FLAGS    ?= -m
 MUSA           ?= musa.py
 # The license is set via bananas.ini, do not supply a "custom" license.
-MUSA_FLAGS     ?= -x license.txt
+MUSA_FLAGS     ?= -x LICENSE
 
 # Bundle
 TAR            ?= tar
@@ -155,64 +149,50 @@
 #
 ################################################################
 
-include Makefile.vcs
-
-ifneq ($(HG),)
-
-# HG revision
-REPO_REVISION  = $(shell HGPLAIN= $(HG) id -n | cut -d+ -f1)
-
-# HG Hash
-REPO_HASH      = $(shell HGPLAIN= $(HG) id -i | cut -d+ -f1)
-
-# HG Date
-REPO_DATE      = $(shell HGPLAIN= $(HG) log -r$(REPO_HASH) --template='{date|shortdate}')
-
-# Whether there are local changes
-REPO_MODIFIED  = $(shell [ "`HGPLAIN= $(HG) id | cut -c13`" = "+" ] && echo "M" || echo "")
-
-# Branch name
-REPO_BRANCH    = $(shell HGPLAIN= $(HG) id -b)
-
-# Any tag which is not 'tip'
-REPO_TAGS      = $(shell HGPLAIN= $(HG) id -t | grep -v "tip")
-
-# Makefile.vcs contains all the data depending on the version reported by HG.
-# It is renewed *before* processing any real targets, *only* if the version of the working copy changes.
-#
-# Everything that uses the version strings (to compile them into some file), should have Makefile.vcs as prerequisite.
-#
+# Always run version detection, so we always have an accurate modified
+# flag
+REPO_VERSIONS := $(shell AWK="$(AWK)" "./findversion.sh")
+REPO_MODIFIED := $(shell echo "$(REPO_VERSIONS)" | cut -f 3 -d'	')
+
+# Use autodetected revisions
+REPO_VERSION := $(shell echo "$(REPO_VERSIONS)" | cut -f 1 -d'	')
+REPO_DATE := $(shell echo "$(REPO_VERSIONS)" | cut -f 2 -d'	')
+REPO_HASH := $(shell echo "$(REPO_VERSIONS)" | cut -f 4 -d'	')
+
+# Days of commit since 2000-01-01. REPO_DATE is in format YYYYMMDD.
+REPO_DATE_YEAR := $(shell echo "${REPO_DATE}" | cut -b1-4)
+REPO_DATE_MONTH := $(shell echo "${REPO_DATE}" | cut -b5-6 | sed s/^0//)
+REPO_DATE_DAY := $(shell echo "${REPO_DATE}" | cut -b7-8 | sed s/^0//)
+REPO_DAYS_SINCE_2000 := $(shell $(PYTHON) -c "from datetime import date; print( (date($(REPO_DATE_YEAR),$(REPO_DATE_MONTH),$(REPO_DATE_DAY))-date(2000,1,1)).days)")
+
+# The version reported to OpenTTD. Usually days since 2000 + branch offset
+NEWGRF_VERSION := $(shell let x="$(REPO_DAYS_SINCE_2000) + 65536 * $(REPO_BRANCH_VERSION)"; echo "$$x")
+
+# The title consists of name and version
+REPO_TITLE     := $(REPO_NAME) $(REPO_VERSION)
+
+# Have a file which, if modified, triggers recompiling targets that use these
+# variables.
 Makefile.vcs: FORCE
 	$(_E) "[VCS] $@"
-	$(_V) echo "REPO_REVISION  ?= $(REPO_REVISION)" > $@.new
-	$(_V) echo "REPO_HASH      ?= $(REPO_HASH)" >> $@.new
-	$(_V) echo "REPO_DATE      ?= $(REPO_DATE)" >> $@.new
-	$(_V) echo "REPO_MODIFIED  ?= $(REPO_MODIFIED)" >> $@.new
-	$(_V) echo "REPO_BRANCH    ?= $(REPO_BRANCH)" >> $@.new
-	$(_V) echo "REPO_TAGS      ?= $(REPO_TAGS)" >> $@.new
+	$(_V) echo "REPO_HASH            = $(REPO_HASH)" >> $@.new
+	$(_V) echo "REPO_DATE            = $(REPO_DATE)" >> $@.new
+	$(_V) echo "REPO_VERSION         = $(REPO_VERSION)" >> $@.new
+	$(_V) echo "NEWGRF_VERSION       = $(NEWGRF_VERSION)" >> $@.new
+	$(_V) echo "REPO_DAYS_SINCE_2000 = $(REPO_DAYS_SINCE_2000)" >> $@.new
 	$(_V) cmp -s $@.new $@ || cp $@.new $@
 	$(_V) -rm -f $@.new
 
-endif
-
-# Days of commit since 2000-1-1 00-00
-REPO_DAYS_SINCE_2000 ?= $(shell $(PYTHON) -c "from datetime import date; print( (date(`echo "${REPO_DATE}" | sed s/-/,/g | sed s/,0/,/g`)-date(2000,1,1)).days)")
-
-# Filename addition, if we're not building the default branch
-REPO_BRANCH_STRING ?= $(shell if [ "$(REPO_BRANCH)" = "$(DEFAULT_BRANCH_NAME)" ]; then echo ""; else echo "-$(REPO_BRANCH)"; fi)
-
-# The version reported to OpenTTD. Usually days since 2000 + branch offset
-NEWGRF_VERSION ?= $(shell let x="$(REPO_DAYS_SINCE_2000) + 65536 * $(REPO_BRANCH_VERSION)"; echo "$$x")
-
-# The shown version is either a tag, or in the absence of a tag the revision.
-REPO_VERSION_STRING ?= $(shell [ -n "$(REPO_TAGS)" ] && echo $(REPO_TAGS)$(REPO_MODIFIED) || echo $(REPO_DATE)$(REPO_BRANCH_STRING) \($(NEWGRF_VERSION):$(REPO_HASH)$(REPO_MODIFIED)\))
-
-# The title consists of name and version
-REPO_TITLE     ?= $(REPO_NAME) $(REPO_VERSION_STRING)
-
 distclean:: clean
 maintainer-clean:: distclean
 
+clean::
+	$(_E) "[CLEAN DEP]"
+	$(_V)-rm -rf $(DEP_FILES)
+
+clean::
+	$(_E) "[CLEAN VCS]"
+	$(_V)-rm -f Makefile.vcs
 
 ################################################################
 #
@@ -226,7 +206,7 @@
 
 %.nml: %.pnml Makefile.vcs
 	$(_E) "[CPP] $@"
-	$(_V) $(CC) -D REPO_REVISION=$(NEWGRF_VERSION) -D NEWGRF_VERSION=$(NEWGRF_VERSION) $(CC_USER_FLAGS) $(CC_FLAGS) -MMD -MF $@.dep -MT $@ -o $@ $<
+	$(_V) $(CC) -D NEWGRF_VERSION=$(NEWGRF_VERSION) $(CC_USER_FLAGS) $(CC_FLAGS) -MMD -MF $@.dep -MT $@ -o $@ $<
 
 clean::
 	$(_E) "[CLEAN NML]"
@@ -314,15 +294,15 @@
 
 grf: $(GFX_FILES) $(GRF_FILES)
 
+# custom_tags.txt is used by NML to replace variables in LNG_FILES
 custom_tags.txt: Makefile.vcs
-	$(_E) "[LNG] $@"
-	$(_V) echo "VERSION        :$(REPO_VERSION_STRING)" > $@
-	$(_V) echo "VERSION_STRING :$(REPO_VERSION_STRING)" >> $@
+	$(_E) "[NML-LNG] $@"
+	$(_V) echo "VERSION        :$(REPO_VERSION)" > $@
+	$(_V) echo "VERSION_STRING :$(REPO_VERSION)" >> $@
 	$(_V) echo "TITLE          :$(REPO_TITLE)" >> $@
 	$(_V) echo "FILENAME       :$(GRF_FILES)" >> $@
 	$(_V) echo "REPO_DATE      :$(REPO_DATE)" >> $@
 	$(_V) echo "REPO_HASH      :$(REPO_HASH)" >> $@
-	$(_V) echo "REPO_BRANCH    :$(REPO_BRANCH)" >> $@
 	$(_V) echo "NEWGRF_VERSION :$(NEWGRF_VERSION)" >> $@
 	$(_V) echo "DAYS_SINCE_2K  :$(REPO_DAYS_SINCE_2000)" >> $@
 
@@ -351,8 +331,8 @@
 	$(_V)-rm -rf $(GRF_FILES)
 	$(_V)-rm -rf $(GRF_FILES).cache
 	$(_V)-rm -rf $(GRF_FILES).cacheindex
-	$(_V)-rm -rf parsetab.py
 	$(_V)-rm -rf .nmlcache
+	$(_V)-rm -rf custom_tags.txt
 
 maintainer-clean::
 	$(_E) "[MAINTAINER-CLEAN GRF]"
@@ -361,11 +341,36 @@
 
 ################################################################
 #
-# Target doc
-#
-# Generate documentation files.
-#
-################################################################
-
-doc: $(DOC_FILES)
-
+# Target obg
+#
+# Create the baseset meta data file.
+#
+################################################################
+
+ifdef OBG_FILENAME
+
+obg: $(OBG_FILENAME)
+
+%.obg: $(GFX_FILES) $(GRF_FILES) $(LNG_FILES) Makefile.vcs
+ifeq ($(GRFID),)
+	$(_E) "Cannot create obg files without grfid. Please install grfcodec, and try again. Aborting."
+	$(_V) false
+endif
+
+	$(_E) "[ASSEMBLING] $@"
+	@echo "[metadata]" > $@
+	@echo "name        = $(REPO_NAME)" >> $@
+	@echo "shortname   = $(REPO_SHORTNAME)" >> $@
+	@echo "version     = $(NEWGRF_VERSION)" >> $@
+	@echo "palette     = $(REPO_PALETTE)" >> $@
+	@echo "blitter     = $(REPO_BLITTER)" >> $@
+	$(_V) $(SCRIPT_DIR)/translations.sh | sed 's/{TITLE}/$(REPO_TITLE)/' >> $@
+
+	@echo "" >> $@
+	@echo "[files]" >> $@
+	$(_V) $(_V)for i in $(BASE_FILENAME); do echo "`echo $$i | cut -d_ -f2` = $$i.grf" >> $@; done
+
+	@echo "" >> $@
+	@echo "[md5s]" >> $@
+	$(_V)for i in $(GRF_FILES); do printf "%-18s = %s\n" $$i `$(GRFID) $(GRFID_FLAGS) $$i` >> $@; done
+
