=== debian/changelog ===
openttd-opengfx (0.6.0-1) unstable; urgency=medium

  * [66ea205] New upstream release 0.6.0
  * [29e237a] Bump debhelper version to v13
  * [54ea987] Bump standards version to 4.5.0 (no changes required)
  * [c02bfbb] Set Rules-Requires-Root: no for building
  * [02382db] Update watch file
  * [839f330] Add patch to fix documentation filenames
  * [0e5588b] No longer check resulting grfids during build

 -- Matthijs Kooijman <matthijs@stdin.nl>  Tue, 12 May 2020 18:35:21 +0200
