=== debian/control ===
--- 
+++ 
@@ -3,11 +3,12 @@
 Priority: optional
 Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
 Uploaders: Jordi Mallach <jordi@debian.org>
-Build-Depends: debhelper (>= 11), nml (>= 0.3.0), gimp, grfcodec, python3
-Standards-Version: 4.3.0
+Build-Depends: debhelper-compat (= 13), nml (>= 0.3.0), gimp, grfcodec, python3
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/openttd-team/openttd-opengfx
 Vcs-Git: https://salsa.debian.org/openttd-team/openttd-opengfx.git
 Homepage: https://github.com/OpenTTD/OpenGFX
+Rules-Requires-Root: no
 
 Package: openttd-opengfx
 Architecture: all
