=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/opengfx-(\d\S+)-source\.(.*)/openttd-opengfx-$1\.$2/ \
  https://www.openttd.org/downloads/opengfx-releases/latest.html .*/opengfx-(\d\S+)-source\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
